function [B E U S V G C] = twopop(mFar,mNear,n)
  m=mFar+mNear; B=zeros(m,n); C=zeros(n,n); E=[]; G=graph;
  % Generate far links
  for r=1:mFar
    p = randi(n/2); q = randi([n/2+1 n]);
    B(r,p) = 1; B(r,q) = -1; E = [E [p; q]]; C(p,q)=1; C(q,p)=1;    
    G=addedge(G,p,q);
  end
  % Generate near links
  for r=mFar+1:mFar+mNear
    p = randi(n/2); q = randi(n/2); % q=min(p+1,n/2);
    B(r,p) = 1; B(r,q) = -1; E = [E [p; q]]; C(p,q)=1; C(q,p)=1;
    G=addedge(G,p,q);
  end
  for r=mFar+mNear+1:mFar+2*mNear
    p = randi([n/2+1 n]); q = randi([n/2+1 n]); % q=min(p+1,n);
    B(r,p) = 1; B(r,q) = -1; E = [E [p; q]]; C(p,q)=1; C(q,p)=1;
    G=addedge(G,p,q);
  end
  % Eliminate duplicate edges and plot graph
  B = unique(B,'rows'); size(B)  
  figure(1); clf; circularGraph(C);
  % Plot singular vectors
  figure(2); clf;
  [U S V] = svd(B);
  
  r=1:n/2; x=V(r,1); y=V(r,2);
  scatter(x,y,'rx'); hold on;
  sr=num2str(r'); cr=cellstr(sr); dx=0.02; dy=0.02;
  text(x+dx,y+dy,cr);
  
  r=n/2+1:n; x=V(r,1); y=V(r,2);  
  scatter(V(n/2+1:n,1),V(n/2+1:n,2),'go')
  sr=num2str(r'); cr=cellstr(sr); dx=0.02; dy=0.02;
  text(x+dx,y+dy,cr);
  axis([-1 1 -1 1]); grid on;
  figure(3); plot(G)
  figure(4); spy(B'*B);
  figure(5); clf; plot(V(:,1),'ro'); hold; plot(V(:,2),'gx');
end